<template lang="pug">
  section.result
    .result__wrap
      h1.result__title.title-1 Результат нашей работы
      .result__slider.slider
        .slider__imgs(v-for="slide in slides" :key="'slide-img-' + slide.id" :class="{active: activeSlide == slide.id}")
          .slider__img: img(:src="require(`@/assets/img/${slide.imgSrc1}`)" :alt="slide.imgSrc1")
          .slider__img: img(:src="require(`@/assets/img/${slide.imgSrc2}`)" :alt="slide.imgSrc2")
        .slider__btns
          .slider__btn.slider__btn--prev(:style="{opacity: activeSlide > 1 ? 1 : 0.4}" @click="prevSlide()" ): img(src="@/assets/img/arrow-hover.svg" alt="prev")
          .slider__btn.slider__btn--next(:style="{opacity: activeSlide < slides.length ? 1 : 0.4}" @click="nextSlide()"): img(src="@/assets/img/arrow-hover.svg" alt="next")
        .slider__main
          ul.slider__wrap(:style="{'margin-left': '-' + 557*(activeSlide-1) + 'px'}")
            li.slider__slide(v-for="slide in slides" :key="'slide-' + slide.id" :style="{opacity: slide.id == activeSlide ? 1 : 0.4}")
              h3.slider__title.title-3 {{slide.title}}
              .slider__text-block
                h5.slider__subtitle Процесс
                p.slider__text {{slide.processText}}
              .slider__text-block
                h5.slider__subtitle Результат работы
                p.slider__text {{slide.resultText}}
        
</template>

<script>
import axios from "axios";

export default {
  name: "vResult",
  data() {
    return {
      activeSlide: 1,
      slides: [],
      endpoint: "http://localhost:3000/slider",
    };
  },
  mounted() {
    const scene5 = this.$scrollmagic
      .scene({
        triggerElement: ".result",
        triggerHook: 0.4,
        reverse: false,
      })
      .setTween(".slider__main", {
        css: {
          transform: "translateX(0)",
        },
      });
    this.$scrollmagic.addScene(scene5);
  },
  methods: {
    async getSlides() {
      try {
        const { data } = await axios.get(this.endpoint);
        this.slides = await data;
        console.log(this.slides);
      } catch (e) {
        console.log(e);
      }
    },
    nextSlide() {
      if (this.activeSlide <= this.slides.length) {
        this.activeSlide++;
        this.activeSlide == this.slides.length + 1
          ? (this.activeSlide = 1)
          : null;
      }
    },
    prevSlide() {
      if (this.activeSlide > 1) {
        this.activeSlide--;
      }
    },
  },
  created() {
    this.getSlides();
  },
};
</script>

<style lang="scss">
.result {
  &__wrap {
    padding-top: 80px !important;
    padding-bottom: 80px !important;
  }
  &__title {
    margin: 0;
    margin-bottom: 57px;

    text-align: center;
  }
}
.slider {
  position: relative;
  overflow-x: hidden;
  @media (max-width: 900px) {
    padding-bottom: 150px;
  }
  @media (max-width: 850px) {
    padding-bottom: 200px;
  }
  @media (max-width: 700px) {
    padding-bottom: 280px;
  }
  &__imgs {
    display: none;
    &.active {
      display: flex;
      animation: opacity 0.3s ease-in-out both;
      @media (max-width: 740px) {
        width: 100%;
        display: grid;
        grid-template-columns: 1fr 1fr;
      }
    }
  }
  &__img {
    @media (max-width: 740px) {
      width: 100%;
      img {
        width: 100%;
        object-fit: cover;
      }
    }
  }
  &__main {
    position: absolute;
    top: 92px;
    left: 670px;
    overflow: hidden;
    transform: translateX(100%);
    @media (max-width: 1238px) {
      left: 300px;
    }
    @media (max-width: 900px) {
      top: 300px;
      left: 100px;
    }
    @media (max-width: 700px) {
      top: 300px;
      left: 20px;
    }
  }
  &__wrap {
    transition: all 0.5s;
  }
  &__btn {
    display: flex;
    justify-content: center;
    align-items: center;

    width: 60px;
    height: 60px;

    box-shadow: 0px 8px 24px rgba(0, 0, 0, 0.1);
    border-radius: 4px;

    background-color: $white;
    cursor: pointer;
    transition: all 0.2s;
    &--prev {
      img {
        transform: rotate(180deg);
      }
      &:hover {
        transform: translateX(-5px);
      }
    }
    &--next {
      &:hover {
        transform: translateX(5px);
      }
    }
  }
  &__btns {
    position: absolute;
    top: 0;
    right: 80px;
    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-gap: 17px;
    @media (max-width: 900px) {
      top: 50px;
    }
  }
  &__wrap {
    display: flex;
    list-style: none;
  }
  &__slide {
    width: 540px;
    min-height: 304px;

    padding: 35px 32px 29px;
    margin-right: 16px;
    margin-bottom: 50px;
    box-sizing: border-box;
    box-shadow: 0px 12px 40px 2px rgba(0, 0, 0, 0.05);
    border-radius: 8px;

    background-color: $white;
    opacity: 0.4;
  }
  &__title {
    margin: 0;
    margin-bottom: 20px;
  }
  &__subtitle {
    margin: 0;
    margin-bottom: 8px;

    font: 700 12px/16px "Museo Sans", sans-serif;
    color: $orange;
    text-transform: uppercase;
  }
  &__text-block {
    margin-bottom: 20px;
    &:last-child {
      margin-bottom: 0px;
    }
  }
  &__text {
    margin: 0;

    font: 400 16px/24px "Museo Sans", sans-serif;
  }
}

@keyframes opacity {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}
</style>
